% :- multifile rule/2.

:- restore( demo ).

% Here alpha is the =, and beta is the #, strategy.

% curtains( alpha, Pr ) :- 
curtains( alpha, Pr ) :-
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	% Second pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	% Second \# Reveal,
	Second = First,
	Pr is p(Second=Gift).

curtains( beta, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	% Second pin uniform([1,2,3]) \# First with 0,
	Second pin uniform([1,2,3]),
	Second \# First,
	Second \# Reveal,
	Pr is p(Second=Gift).

curtains( gamma_half, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Second \# Reveal,
	Pr is p(Second=Gift).

curtains( gamma, ChooseOtherWith, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Second \# ChooseOtherWith :: First,
	Second \# Reveal,
	Pr is p(Second=Gift).

curtains( gamma_one, ChooseOtherWith, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Second # X \\ ChooseOtherWith :: First = X,
	Second \# Reveal,
	Pr is p(Second=Gift).

curtains( gamma_two, ChooseOtherWith, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Caller = curtains/3,
	in_num_to_fraction( ChooseOtherWith, Caller, RatCow ),
	rationals_prob_compliment( RatCow, OneMinus ),
	Second # X :: RatCow ++ Second = X :: OneMinus \\ First = X,
	Second \# Reveal,
	Pr is p(Second=Gift).

curtains( gamma_thr, ChooseOtherWith, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Caller = curtains/3,
	in_num_to_fraction( ChooseOtherWith, Caller, RatCow ),
	rationals_prob_compliment( RatCow, OneMinus ),
	Second # X :: RatCow ++ Second = X :: OneMinus \\ First = X,
	Second \# Reveal,
	Pr is p(Second=Gift).

%  curtains(gamma_incorr_one, 1, P1 ). P1 = 2/3.
%  curtains(gamma_incorr_one, 0, P0 ). P0 = 0/1.
curtains( gamma_incorr_one, ChooseOtherWith, Pr ) :- 
	Gift pin uniform([1,2,3]),
	First pin uniform([1,2,3]),
	Reveal pin uniform([1,2,3]),
	Reveal \# Gift,
	Reveal \# First, 
	Second pin uniform([1,2,3]),
	Second # X :: ChooseOtherWith \\ First = X,
	Second \# Reveal,
	Pr is p(Second=Gift).

:- demo.
