:- restore( demo ).

%
% For Cartesian qualifiers and Intersective dependants
% space( [a,b,c,d], [19/52,15/104,19/52,1/8] ).
%    pfd | ?- L is 38 + 15 + 38 + 13.  L=104 ?
%
space( Value, Prb ) :-
	V3 pin finite_geometric([a,b,c],[3]),
	V4 pin uniform([a,b,c,d]),
	r1(V4) :: 1/3 ++ r2(V4) :: 2/3 \\  c1(V3),
	r3(V4) :: 1/4 ++ r4(V4) :: 3/4 \\  c2(V3),
	Prb is p(V4==Value).

% space_trans( [a,b], [313/520,207/520] ).
%    pfd | ?- L is 313 + 207.  L=520 ?
%
space_trans( Value, Prb ) :-
	V3 pin finite_geometric([a,b,c],[3]),
	V4 pin uniform([a,b,c,d]),
	V5 pin uniform([a,b]),
	r1(V4) :: 1/3 ++ r2(V4) :: 2/3 \\  c1(V3),
	r3(V4) :: 1/4 ++ r4(V4) :: 3/4 \\  c2(V3),
	% r3(V4) :: 1/4 \> r4(V4) :: 2/4 \\  c2(V3),
	% CHECK consistency Sum = 1
	r2(V5) :: 2/5 ++ r3(V5) :: 3/5 \\  c1(V4),
	Prb is p(V5==Value).
	
/*
space_multi( a, P ).
Pa = 15/52, Pb = 45/208, Pc = 4/13, Pd = 3/16 . Sum  = 1.
*/
space_multi( Value, Prb ) :-
	V3 pin finite_geometric([a,b,c],[3]),
	V4 pin uniform([a,b,c,d]),
	V5 pin uniform([a,b]),
	r1(V4) :: 1/3 ++ r2(V4) :: 2/3 \\  c3(V3,V5),
	r3(V4) :: 1/4 ++ r4(V4) :: 3/4 \\  c2(V3),
	Prb is p(V4==Value).

r1( a ). r1( b ). r1( d ).
r2( a ). r2( c ).
r3( a ). r3( b ).
r4( b ). r4( c ). r4( d ).
c1( a ). c1( b ).
c2( b ). c2( c ).
c3( a, a ). c3( b, a ).

:- demo.
